Loading...
Searching...
No Matches
juce::ARAEditorRenderer Class Reference

## Detailed Description

Base class for a renderer fulfilling the ARAEditorRenderer role as described in the ARA SDK.

Instances of this class are constructed by the DocumentController. If you are subclassing ARAEditorRenderer, make sure to call the base class implementation of any overridden function, except for processBlock.

The documentation for this class was generated from the following file:

- juce_audio_processors_headless/utilities/ARA/juce_ARAPlugInInstanceRoles.h

Inheritance diagram for juce::ARAEditorRenderer:

## Public Member Functions

template<typename PlaybackRegion_t = ARAPlaybackRegion>
std::vector< PlaybackRegion_t * > const & | getPlaybackRegions () const noexcept
template<typename RegionSequence_t = ARARegionSequence>
std::vector< RegionSequence_t * > const & | getRegionSequences () const noexcept
bool | processBlock (AudioBuffer< float > &buffer, AudioProcessor::Realtime isNonRealtime, const AudioPlayHead::PositionInfo &positionInfo) noexcept override
| Renders the output into the given buffer.
virtual bool | processBlock (AudioBuffer< double > &buffer, AudioProcessor::Realtime realtime, const AudioPlayHead::PositionInfo &positionInfo) noexcept
| Renders the output into the given buffer.
Public Member Functions inherited from juce::ARARenderer
virtual | ~ARARenderer ()=default
virtual void | prepareToPlay (double sampleRate, int maximumSamplesPerBlock, int numChannels, AudioProcessor::ProcessingPrecision precision, AlwaysNonRealtime alwaysNonRealtime=AlwaysNonRealtime::no)
| Initialises the renderer for playback.
virtual void | releaseResources ()
| Frees render resources allocated in prepareToPlay().
virtual void | reset ()
| Resets the internal state variables of the renderer.

## Additional Inherited Members

Public Types inherited from juce::ARARenderer
enum class | AlwaysNonRealtime { no , yes }

## Member Functions

## getPlaybackRegions()

template<typename PlaybackRegion_t = ARAPlaybackRegion>

std::vector< PlaybackRegion_t * > const & juce::ARAEditorRenderer::getPlaybackRegions | ( |  | ) | const

inline noexcept

## getRegionSequences()

template<typename RegionSequence_t = ARARegionSequence>

std::vector< RegionSequence_t * > const & juce::ARAEditorRenderer::getRegionSequences | ( |  | ) | const

inline noexcept

## processBlock() [1/2]

bool juce::ARAEditorRenderer::processBlock | ( | AudioBuffer< float > & | buffer,
|  | AudioProcessor::Realtime | realtime,
|  | const AudioPlayHead::PositionInfo & | positionInfo )

override virtual noexcept

Renders the output into the given buffer.

Returns true if rendering executed without error, false otherwise.

Parameters

  buffer | The output buffer for the rendering. ARAPlaybackRenderers will replace the sample data, while ARAEditorRenderer will add to it.
  realtime | Indicates whether the call is executed under real time constraints. The value of this parameter may change from one call to the next, and if the value is yes, the rendering may fail if the required samples cannot be obtained in time.
  positionInfo | Current song position, playback state and playback loop location. There should be no need to access the bpm, timeSig and ppqPosition members in any ARA renderer since ARA provides that information with random access in its model graph.

Returns false if non-ARA fallback rendering is required and true otherwise.

Implements juce::ARARenderer.

References juce::ARARenderer::processBlock().

## processBlock() [2/2]

virtual bool juce::ARARenderer::processBlock | ( | AudioBuffer< double > & | buffer,
|  | AudioProcessor::Realtime | realtime,
|  | const AudioPlayHead::PositionInfo & | positionInfo )

virtual noexcept

Renders the output into the given buffer.

Returns true if rendering executed without error, false otherwise.

Parameters

  buffer | The output buffer for the rendering. ARAPlaybackRenderers will replace the sample data, while ARAEditorRenderer will add to it.
  realtime | Indicates whether the call is executed under real time constraints. The value of this parameter may change from one call to the next, and if the value is yes, the rendering may fail if the required samples cannot be obtained in time.
  positionInfo | Current song position, playback state and playback loop location. There should be no need to access the bpm, timeSig and ppqPosition members in any ARA renderer since ARA provides that information with random access in its model graph.

Returns false if non-ARA fallback rendering is required and true otherwise.

Reimplemented from juce::ARARenderer.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited